; Internal RC oscillator
; FX=11111111($ff)
; FH=11011001($d9) BODat4.3V
; FL=01100010($62) 4MHzRCintOsc/8 (2us/cycle)
; LB=11111111($ff)

; 2313's Prog_enable=XA1,XA0,PAGEL/BS1,WR#(PD6,5,4,3)
; Mega's Prog_enable=XA1,XA0,PAGEL,BS1(PD6,5,4,2)

; PA1/XTAL2(start Button)
; PA0/XTAL1(Clock out)
; PB7-PB0(DATA bus)
; PD6(XA1)
; PD5(XA0)
; PD4(BS1)
; PD3(WR#)
; PD2(PAGEL-onlyMega)
; PD1(RDY/BSY#)
; PD0(BS2-onlyMega)

#include	"common.inc"

; tiny2313 :4MHzOSC 1/1 slowRisePower
; Mega328P :default reset
#if ! defined(FUSE_LOW_VALUE)
#	define	FUSE_LOW_VALUE	0x62
#endif

; tiny2313 :default reset
; Mega328P :default & bootLDBLK=4P(512W)
#if ! defined(FUSE_HIGH_VALUE)
#	define	FUSE_HIGH_VALUE	0xdf
#endif

; tiny2313 :default reset
; Mega328P :default reset
#if ! defined(FUSE_EXT_VALUE)
#	define	FUSE_EXT_VALUE	0xff
#endif

; tiny2313 :default reset
; Mega328P :default reset
#if ! defined(FUSE_LOCK_VALUE)
#	define	FUSE_LOCK_VALUE	0xff
#endif


.section	.text
.align	1
.org	0x0000
SYS_VECT:
	RJMP	RESET		; 0x00
	RJMP	EXT_INT0	; 0x01
	RJMP	EXT_INT1	; 0x02
	RJMP	TIM1_CAPT	; 0x03
	RJMP	TIM1_COMPA	; 0x04
	RJMP	TIM1_OVF	; 0x05
	RJMP	TIM0_OVF	; 0x06
	RJMP	USART_RXC	; 0x07
	RJMP	USART_UDRE	; 0x08
	RJMP	USART_TX	; 0x09
	RJMP	ANA_COMP	; 0x0a
	RJMP	PCINT		; 0x0b
	RJMP	TIM1_COMPB	; 0x0c
	RJMP	TIM0_COMPA	; 0x0d
	RJMP	TIM0_COMPB	; 0x0e
	RJMP	USI_START	; 0x0f
	RJMP	USI_OVF		; 0x10
	RJMP	WW_RDY		; 0x11
	RJMP	WDT_OVF		; 0x12

EXT_INT0:
EXT_INT1:
TIM1_CAPT:
TIM1_COMPA:
TIM1_OVF:
TIM0_OVF:
USART_RXC:
USART_UDRE:
USART_TX:
ANA_COMP:
PCINT:
TIM1_COMPB:
TIM0_COMPB:
USI_START:
USI_OVF:
WW_RDY:
WDT_OVF:
_CPU_HALT:	; ߤޤ
	LDI 	r24, RAMEND
	OUT 	SPL, r24
	CLR 	r24
	OUT 	SREG, r24
	SLEEP
	RJMP	_CPU_HALT

; /*******************************************************************/
;	initial at reset
RESET:
	LDI 	r24,RAMEND
	OUT 	SPL,r24
	LDI 	r24,(1<<SE)	; PUEnable,SE,Idle@sleep
	OUT 	MCUCR, r24

; /*******************************************************************/
;
Stop_AD:	; ADC,Vrefߤ
	LDI 	r24, 0x90
	OUT 	ACSR, r24

Main_init:
; Port-A
	CLR 	r24 	; PA1/XTAL2(start Button) set INPUT ,PA0/XTAL1 set OUTPUT
	OUT 	PORTA, r24
	LDI 	r24, 0x01
	OUT 	DDRA, r24

; Port-B
	SER 	r24
	OUT 	PORTB, r24	; all-H or pull-up
	OUT 	DDRB, r24	; all ports set OUTPUT

; Port-D
	LDI 	r24,0x03
	OUT 	PORTD, r24	; set Prog_enable(PD6-2=0) state
	LDI 	r24, 0x7d	; PD1(RDY/BSY#) set INPUT ,other pins set OUTPUT
	OUT 	DDRD, r24

.Port_init_done:

; *** setup TIM0 (increment fcnt_1ms and decrement dcnt_1ms if it is not zero every ms)
	RCALL	_INIT_TIM0

; *** enable interrupts
	SEI

0:
	RCALL	_wait_2ms
	AND 	sw_count, sw_count	; SWOFFˤޤǥ롼
	BRNE	0b

	RCALL	_main

3:	; λLEDǤԵ
	SLEEP
	LDI 	r26,0x02
	CLR 	led_on
	AND		r26,fcnt_1ms_h
	BRNE	3b
	COM 	led_on
	RJMP	3b
;	RJMP	_CPU_HALT
;	RJMP	RESET



;Main_Loop/////////////////////////////////////////////////////
BEGIN	_main
1:
	SLEEP
	RCALL	_wait_sw	; start_sw줿
	AND 	r24, r24
	BREQ	1b  		; ޤԵ

	LDI 	r24, 0x0a	; WR# is negate, RDY/BSY# pull uped
	OUT 	PORTD, r24	; set Idle state
	RCALL	_wait_2ms


	RCALL	_wait_2ms
	RCALL	_chip_erase

	RCALL	_wait_2ms
	LDI 	r24, FUSE_EXT_VALUE
	RCALL	_write_fuse_ex

	RCALL	_wait_2ms
	LDI 	r24, FUSE_HIGH_VALUE
	RCALL	_write_fuse_hi

	RCALL	_wait_2ms
	LDI 	r24, FUSE_LOW_VALUE
	RCALL	_write_fuse_lo

RETURN


BEGIN	_wait_2ms
	PUSH	r24
	LDI 	r24, 2
	MOV 	dcnt_1ms, r24
	POP 	r24
1:
	SLEEP	; TIM0dcnt_1msΤԤ
	AND 	dcnt_1ms, dcnt_1ms
	BRNE	1b
RETURN

BEGIN	_wait_sw
	LDI 	r24, 100
	CP  	r24, sw_count ; SW on till over 100ms
	BRCS	1f	; branch if carry is set(r24<sw_count)
	CLR 	r24		; clear return value if r24>sw_count
1:
RETURN

.macro	setADDRESS
	CBI 	PORTD, 6	;XA1=0
	CBI 	PORTD, 5	;XA0=0
.endm
.macro	setCOMMAND
	SBI 	PORTD, 6	;XA1=1
	CBI 	PORTD, 5	;XA0=0
.endm
.macro	setDATA
	CBI 	PORTD, 6	;XA1=0
	SBI 	PORTD, 5	;XA0=1
.endm
.macro	setIDLE
	SBI 	PORTD, 6	;XA1=1
	SBI 	PORTD, 5	;XA0=1
.endm


.macro	pulseWR
	CBI 	PORTD, 3
	NOP
	SBI 	PORTD, 3
	NOP
.endm

.macro	pulseXTAL1
	SBI 	PORTA, 0
	NOP
	CBI 	PORTA, 0
	NOP
.endm

#define cmd_CHIP_ERASE 0x80
#define cmd_FUSE_WRITE 0x40
#define cmd_LOCK_WRITE 0x20
#define cmd_FLASH_WRITE 0x10
#define cmd_EEPROM_WRITE 0x11

.macro	cmdFUSE	reg
	SER 	\reg
	OUT 	DDRB, \reg
	setCOMMAND
	CBI 	PORTD, 4	;BS1=0
	CBI 	PORTD, 0	;BS2=0
	LDI 	\reg, cmd_FUSE_WRITE
	OUT 	PORTB, \reg
	pulseXTAL1
.endm

.macro	lo_FUSE	reg
	setDATA
	CBI 	PORTD, 4	;BS1=0
	CBI 	PORTD, 0	;BS2=0
	OUT 	PORTB, \reg
	pulseXTAL1
.endm

.macro	hi_FUSE	reg
	setDATA
	CBI 	PORTD, 4	;BS1=0
	CBI 	PORTD, 0	;BS2=0
	OUT 	PORTB, \reg
	pulseXTAL1
	SBI 	PORTD, 4	;BS1=1
.endm

.macro	ex_FUSE	reg
	setDATA
	CBI 	PORTD, 4	;BS1=0
	CBI 	PORTD, 0	;BS2=0
	OUT 	PORTB, \reg
	pulseXTAL1
	SBI 	PORTD, 0	;BS2=1
	SBI 	PORTD, 6	;BS2=1
.endm



; PA1/XTAL2(start Button)
; PA0/XTAL1(Clock out)
; PB7-PB0(DATA bus)
; PD6(XA1/tinyBS2)
; PD5(XA0)
; PD4(BS1/tinyPAGEL)
; PD3(WR#)
; PD2(PAGEL-onlyMega)
; PD1(RDY/BSY#)
; PD0(BS2-onlyMega)

BEGIN	_chip_erase
	SER 	r25
	OUT 	DDRB, r25	; all portBs are output

	setCOMMAND			; set command mode XA1=1 XA0=0
	CBI 	PORTD, 4	; BS1=0
	LDI 	r25, cmd_CHIP_ERASE
	OUT 	PORTB, r25	;
	pulseXTAL1

	pulseWR
; WR#->BSY# delay 1us
	CBI 	DDRD, 1
2:
	SBIS	PIND, 1	; RDY/BSY#ɤ߼äƥå(H)ʤ饹å
	RJMP	2b	; RDY/BSY#Hˤʤޤǥ롼פ
RETURN

BEGIN	_write_fuse_lo
	cmdFUSE 	r25
	lo_FUSE 	r24
	pulseWR
	CBI 	DDRD, 1
2:
	SBIS	PIND, 1	; RDY/BSY#ɤ߼äƥå(H)ʤ饹å
	RJMP	2b	; RDY/BSY#Hˤʤޤǥ롼פ
RETURN

BEGIN	_write_fuse_hi
	cmdFUSE 	r25
	hi_FUSE 	r24
	pulseWR
	CBI 	DDRD, 1
2:
	SBIS	PIND, 1	; RDY/BSY#ɤ߼äƥå(H)ʤ饹å
	RJMP	2b	; RDY/BSY#Hˤʤޤǥ롼פ
RETURN

BEGIN	_write_fuse_ex
	cmdFUSE 	r25
	ex_FUSE 	r24
	pulseWR
	CBI 	DDRD, 1
2:
	SBIS	PIND, 1	; RDY/BSY#ɤ߼äƥå(H)ʤ饹å
	RJMP	2b	; RDY/BSY#Hˤʤޤǥ롼פ
RETURN


; /*******************************************************************************/
; ߥ롼
; r0  ߥ롼ǤΤ߻ȤƤݾڤʤ(SREG¸)

; /*******************************************************************************/
; ΰ (PROGMEM2Хȶ)
.align	1

.section .bss
.align	0

.end
